modules/adhocproject/controllers/DocumentController.php
<?php


namespace app\modules\adhocproject\controllers;


use Yii;
use app\models\Document;
use yii\web\UploadedFile;
use yii\web\NotFoundHttpException;
use app\controllers\BaseController;

class DocumentController extends BaseController {

public function actionIndex() {
     
          $dataProvider = new ActiveDataProvider([
               
                'query' => Document::find()  
          ]);
            $dataProvider->pagination  = false;
        
            return $this->render('index', ['dataProvider' => $dataProvider,]);
 
    }

    public function actionCreate($id) {

        $projectId = $_REQUEST['id'];

        $model = new Document();
        if ($model->load(Yii::$app->request->post())) {

            $postData = Yii::$app->request->post();

            $filenameDoc = '';
            $uploads = UploadedFile::getInstances($model, 'document');
            if (!empty($uploads)) {
                $path=Yii::$app->params['domain_path']."/web/";
                $documentList = [];
                $dirname = $projectId;
                $Subfolder = "document";
                $folder = 'uploads/project/' . $dirname . '/';
                $filename = 'uploads/project/' . $dirname . '/'.$Subfolder.'/';

                  $directorypath=$path.'uploads/project/' . $dirname . '/'.$Subfolder.'/';
                // mkdir($directorypath,0777,true);

                foreach ($uploads as $key => $upload) {
                    $description = $postData['Document']['description'][$key];
                    if (file_exists($filename)) {
                        $filenameDoc = $filename . $upload->baseName . '_' . time() . '.' . $upload->extension;
                    } else {
                        if (file_exists($folder)) {
                        

                        $filenameDoc = $filename . $upload->baseName . '_' . time() . '.' . $upload->extension;
                        }
                        else{

                       // mkdir('uploads/project/' . $dirname . '/');
                       // mkdir(,true);

                        } 
                        
                    }

                    $upload->saveAs($filenameDoc);
                    $document = new \app\models\Document();

                    $document->project_id = $projectId;
                    $document->description = $description;
                    $document->document = $upload->baseName . '_' . time() . '.' . $upload->extension;

                    if (!$document->save()) {
                        pr($document->getErrors());
                    }
                }
            }

        } else {

            return $this->renderAjax('create', [
                        'model' => $model,
            ]);
        }
    }

   
    public function actionUpdate($id) {
        
        $ID = $_REQUEST['id'];
       
        $DocumentData = Document::find()->where(['id' => $ID])->asArray()->one();
        $projectID = $DocumentData['project_id'];
        $model = $this->findModel($id);

        if ($model->load(Yii::$app->request->post())) {
            $request = Yii::$app->request->post();

            $model->document = $request['current_document'];
            $uploadDocument = UploadedFile::getInstance($model, 'document');
            if (!empty($uploadDocument)) {
                
                if ($model->document = $uploadDocument) {

                    $directoryName = $projectID;
                    $SubfolderName = "document";
                    $folderName = 'uploads/project/' . $directoryName . '/';
                    $filePath = 'uploads/project/' . $directoryName . '/'.$SubfolderName.'/';
                    // pr($filename);
                    if (file_exists($filePath)) {
                          
                        $fileName = $filePath . $model->document->baseName . '_' . time() . '.' . $model->document->extension;
                       
                    } 
                    else {
                        if (file_exists($folderName)) {
                            
                        mkdir('uploads/project/' . $directoryName . '/'.$SubfolderName.'/');
                        $fileName = $filePath . $model->document->baseName . '_' . time() . '.' . $model->document->extension;
                       
                        }
                        
                        else{
                        //mkdir('uploads/project/' . $directoryName . '/');
                        mkdir('uploads/project/' . $directoryName . '/'.$SubfolderName.'/',true);
                        $fileName = $filePath . $model->document->baseName . '_' . time() . '.' . $model->document->extension;
                         
                        } 
                    }
                    $model->document->saveAs($fileName);
                    $model->document = $model->document->baseName . '_' . time() . '.' . $model->document->extension; 
                }
            
            }
            
           
            if (!$model->save()) {
                pr($model->getErrors());
            }
            return $this->redirect(yii::$app->request->referrer."#documents");
        } 
        else {
            return $this->renderAjax('update', [
                        'model' => $model,
            ]);
        }
    }

    protected function findModel($id) {
        if (($model = Document::findOne($id)) !== null) {
            return $model;
        } else {
            throw new NotFoundHttpException('The requested page does not exist.');
        }
    }

    public function actionDeletes($id) {
        //pr($id);
        $this->findModel($id)->delete();

        return $this->redirect(Yii::$app->request->referrer."#documents");
    }

    public function actionDownload($id)
    {

        $download = Document::findOne($id);
        $dirname = $download['project_id'];
        //$filename = $download->document;
       // pr($filename);
        $path = Yii::getAlias('@webroot').'/uploads/project/' . $dirname . '/document/'.$download->document;
        //pr($path);
         if (file_exists($path)) {
            return Yii::$app->response->sendFile($path);
        } else {
            throw new NotFoundHttpException("can't find {$download->document} file");
        }
    }

}

modules/adhocproject/views/document/create.php
<?php

use yii\web\View;
use yii\widgets\ActiveForm;
use yii\helpers\Html;



$projectId=$_GET['id'];

$projectname = app\models\AdhocProject::find()->where(['id'=>$projectId])->asArray()->one();
$name = $projectname['project_name'];
//pr($name);

?>
<div id='msg' class='msg'></div>
<?php
$form = ActiveForm::begin([
            'id' => 'active-form',
            'options' => [
                'class' => 'invoice-form form-horizontal',
                'enctype' => 'multipart/form-data'
            ],
        ])
?>

<div id="document-form">
    <div class="row">

        
    <div class="col-md-12" style="font-size: 15px;font-weight: bold">  <legend class="text-info"><small> <?php   echo ucfirst(strtolower($name));?></small></legend></div>
        <div class="col-md-12" input-group-btn style="margin-top:21px">
            <button class="btn btn-success add-more" type="button"><i class="fa fa-gear"></i> Add More Documents</button>

<div >&nbsp;</div>
        </div>
     <div class="row hide" id="error-message"><div class="col-md-12 warning"></div></div>
        <div class ="row">
             <div class="col-md-6" style="font-weight:bold">Description</div>
             <div class="col-md-6" style="font-weight:bold">Document</div>
         
        </div>
     <div>&nbsp;</div>
        <div id="documentupload">
            <div class="row copyinvitems details after-add-more">
                <div class="control-group">
         <div class="col-md-6"><input type="text" class="form-control" name="Document[description][]"></div>
         <div class="col-md-5"><input type="file" class="form-control" name="Document[document][]"></div>
                   
                </div>

            </div>
        </div>



        <div class="col-md-12"><legend class="text-info"><small></small></legend></div>

        <div class="col-md-12"> 
            <div class="form-group">
                <div class="col-md-12 col-xs-12">
                    <?= Html::submitButton($model->isNewRecord ? 'Submit' : 'Update', ['id'=>'submit','class' => $model->isNewRecord ? 'btn btn-success pull-right' : 'btn btn-primary pull-right']) ?>
                </div>
            </div>
        </div>
   
    <?php
    ActiveForm::end();
    ?>
</div>
 </div>
    <?php
    $js = <<< JS

    var counter = 1;
    $(".add-more").click(function () {
        var newContainer = $(document.createElement('div'));
        newContainer.after().html('<div class="clear">&nbsp;</div><div class="control-group">' +
        '<div class="col-md-6"><input type="text" class="form-control" name="Document[description][]"></div>'+
        '<div class="col-md-5"><input type="file" class="form-control" name="Document[document][]"></div>'+   
        '<div class="col-md-1 rmbtn" style="margin-top:0px"><button class="btn btn-danger remove" type="button"><i class="glyphicon glyphicon-remove" style="font-size:10px; margin-right:0px;"></i></button></div>'+
        '</div>');
        newContainer.appendTo("#documentupload");
        counter++;
    });

    $('body').on('click','.remove',function(){ 
        $(this).parents('.control-group').remove();
    });

JS;
    $this->registerJs($js);
    ?>

  
<script> 
$("form#active-form").submit(function(e) {
    e.preventDefault();
    event.stopPropagation();
    var formData = new FormData(this);  
    
                 var description = document.getElementsByName('Document[description][]');
                 var documents = document.getElementsByName('Document[document][]');
               
                 $("#error-message").removeClass("hide");
                 for (k=0; k<description.length; k++) {
                    $(description[k]).removeClass("error-highlight");
                    $(documents[k]).removeClass("error-highlight");
                   
                    }
                    for (i=0; i<description.length; i++) {
                        if (description[i].value == '') {
                            $("#error-message").html("<p>Description can not be blank</p>");
                            $("decription[i]").addClass("error-highlight");
                            return false;
                        } 
                        else if (documents[i].value == '') {
                            $("#error-message").html("<p>Document cannot be empty</p>");
                            $(documents[i]).addClass("error-highlight");
                            return false;
                        }
                      }
                $("#error-message").addClass("hide");
        
  
    
    $.ajax({
        url: $('#active-form').attr('action'),
        type: 'POST',
        data: formData,
        success: function(){
                      $("#msg").html('Document Uploaded');
                      $("#msg").show();
                      setTimeout(function() { $("#msg").fadeOut('slow'); }, 4000);
                      document.getElementById("active-form").reset();
                      window.location.href = window.location.href .split('#')[0] + "#documents" ;
                      location.reload();

            },
        cache: false,
        contentType: false,
        processData: false
    });
});
</script>

modules/adhocproject/views/document/index.php
<?php

use yii\helpers\Html;
use yii\bootstrap\Modal;
use kartik\grid\GridView;
use yii\helpers\Url;
use yii\web\View;

$id=$_GET['id'];
//$products = app\models\Products::find()->where(['project_id' => $id])->asArray()->all();
?>
<?php
            
    Modal::begin([
        'header' => '<h4>Update Document</h4>',
        'id' => 'updatedoc',
        'size' => 'modal-lg',
        'clientOptions' => ['backdrop' => 'static', 'keyboard' => FALSE]
    ]);

    echo "<div id ='modaldocupdate'><div class='loader'></div></div>";
    Modal::end();
    ?>
<?php
Modal::begin([
        'header' => '<h4>Upload Documents</h4>',
        'id' => 'upload',
        'size' => 'modal-lg',
        'clientOptions' => ['backdrop' => 'static', 'keyboard' => FALSE]
    ]);

    echo "<div id ='modaluploaddoc'><div class='loader'></div></div>";
    Modal::end();
?>
<div class="row">
<div class="col-md-12">

    <p class="text-right" >
        <?=Html::a(Yii::t('app', ' {modelClass}', [
                   'modelClass' => 'Add Document',
                    ]), ['document/create', 'id' => $model->id], ['class' => 'btn btn-success', 'id' => 'modalDocumentupload']);
?>  </p> 
     <legend class="text-info"><small>Documents</small></legend>
 </div>
</div>
 <?php
 
if ($dataProvider) {
    echo GridView::widget([
        'dataProvider' => $dataProvider,
        'responsiveWrap' =>false,
        'columns' => [
            ['class' => 'kartik\grid\SerialColumn', 'mergeHeader' => false,],

        [
            'attribute' => 'description',
            'header' => '<div style="width:120px;">Description</div>',
            'value' =>  'description',
           
        ],
        
       ['attribute'=>'Attachment',
        'header' => '<div style="width:30px;">Attachment</div>',
        'format'=>'raw',
        'value' => function($model)
        {
        return
        Html::a('<div style="text-align:center; font-size:18px;"><span class="fa fa-download"></span></div>', ['document/download', 'id' => $model->id]);

        }
        ],
  
[
                'class' => 'kartik\grid\ActionColumn',
                'mergeHeader' => false,
                'vAlign' => 'middle',
                'header' => '<div style="width:150px;">Actions</div>',
                'template' => ' {update}{deletes}',
                'buttons' => [
                   'update' => function ($url, $model, $key) {
                           
                                return Html::a('<span class="glyphicon glyphicon-edit icons"></span>', Url::to(['document/update', 'id' => $model->id]),
                                    [
                                        'class'=>'updatedocmt',
                                        'title' => 'Edit',
                                       // 'data-pjax' => '0',
                                        
                                    ]
                                );
                            
                        },
                    'deletes' =>function ($url, $model, $key) {
                            
                                return Html::a('<span class="glyphicon glyphicon-trash icons"></span>', Url::to(['document/deletes', 'id' => $model->id]),
                                    [
                                       // 'class'=>'delete',
                                        'title' => 'Delete','data' => ['confirm' => 'Are you sure want to delete?'],
                                       // 'data-pjax' => '0',
                                        
                                    ]
                                );
                            
                        },   
                ],
            ],
       ],         
        
       'headerRowOptions' => ['class' => 'kartik-sheet-style'],
    'filterRowOptions' => ['class' => 'kartik-sheet-style'],
    'pjax' => false, // pjax is set to always true for this demo
    
    'summary' => '',
//    'panel' => [
//        'type' => GridView::TYPE_PRIMARY,
//        'heading' => '',
//    ],
    
    ]);
}

?>  


<?php
$this->registerJs("$(function() {
   $('#modalDocumentupload').click(function(e) {
     e.preventDefault();
     $('#upload').modal('show').find('#modaluploaddoc')
     .load($(this).attr('href'));
   });
});", View::POS_READY);
 ?>

<?= $this->registerJs(

  "$(document).on('ready pjax:success', function() {  // 'pjax:success' use if you have used pjax
    $('.updatedocmt').click(function(e){
       e.preventDefault();      
       $('#updatedoc').modal('show')
                  .find('#modaldocupdate')
                  .load($(this).attr('href'));  
   });
});
", View::POS_READY);
 ?>

modules/adhocproject/views/document/update.php
<?php

use yii\web\View;
use yii\widgets\ActiveForm;
use yii\helpers\Html;

$DocumentId=$_GET['id'];

$Document = app\models\Document::find()->where(['id'=>$DocumentId])->asArray()->one();
$projectId=$Document['project_id'];

$projectname = app\models\Project::find()->where(['id'=>$projectId])->asArray()->one();
$name = $projectname['project_name'];




?>

<?php
$form = ActiveForm::begin([
            'id' => 'active-form',
            'options' => [
                'class' => 'invoice-form form-horizontal',
                'enctype' => 'multipart/form-data'
            ],
        ])
?>
<div id='msg' class='msg'></div>
   <div class="customer-form form-vertical">
    <?php $form = ActiveForm::begin(); ?>
  <div class="row">
       <div class="row">
          <div class="col-md-12" style="font-size: 15px;font-weight: bold">  <legend class="text-info"><small> <?php   echo ucfirst(strtolower($name));?></small></legend></div>
     </div>
     <div class="row">
        
         <div class="col-md-6">
            <?=
            $form->field($model, 'description', [
                'template' => "{label}\n
      <div class='col-md-12 col-xs-12'>
            {input}\n
            {hint}\n
            {error}
      </div>",
                'labelOptions' => ['class' => 'col-md-12 col-xs-12 control-label', 'style' => 'color:black'],
              
            ])->textInput(['placeholder' => " "])->label('Description')
            ?>
         </div>
  
        <div class="col-md-6">
           <?php $documentpath=\Yii::$app->params['domain_url'].$model->document;?>
    <?php if(is_null($model->document) || empty($model->document)): ?>
        <?= $form->field($model, 'document', [
          'template' => "{label}\n
          <div class='col-md-9'>
                {input}\n
                {hint}\n
                {error}
          </div>",
          'labelOptions' => [ 'class' => 'col-md-12 control-label' ],
          'inputOptions' => [ 'class' => 'file', 'data-show-upload' => "false",'data-show-preview'=>"false" ]
        ])->fileInput() ?>
    <?php else: ?>
  
 
        <?= $form->field($model, 'document', [
          'template' => "{label}\n
          <div class='col-md-9 col-xs-9'>
                {input}\n
                <div class='file-preview'>
                  <strong> Current File </strong> : 
                    <div class='clearfix'></div>
                     <a base href='$documentpath'target='_blank'> $model->document</a>
                
                {hint}\n
                {error}
          </div></div>",
          'labelOptions' => [ 'class' => 'col-md-12 control-label' ],
          'inputOptions' => [ 'class' => 'file', 'data-show-upload' => "false",'data-show-preview'=>"false" ]
        ])->fileInput() ?>
    <?php endif; ?>
        </div>
     
           </div>   
     
         
        <div class="form-group">
            <label class="col-md-12 col-xs-12 control-label" for=""></label>
            <div class="col-md-12 col-xs-12">
<input type="hidden" name="current_document" value="<?php echo $model->document; ?>">
<?= Html::submitButton($model->isNewRecord ? 'Submit' : 'Update', ['class' => $model->isNewRecord ? 'btn btn-success pull-right' : 'btn btn-primary pull-right']) ?>
            </div>
        </div>
  </div>
<?php ActiveForm::end(); ?>  
        </div>

   
<script> 
    
$("form#active-form").submit(function(e) {
    e.preventDefault();    
    var formData = new FormData(this);

    $.ajax({
        url: $('#active-form').attr('action'),
        type: 'POST',
        data: formData,
        success: function(){
                      $("#msg").html('Document Updated');
                      $("#msg").show();
                      setTimeout(function() { $("#msg").fadeOut('slow'); }, 4000);
                      document.getElementById("active-form").reset();

            },
        cache: false,
        contentType: false,
        processData: false
    });
});
</script>